//
// ksd.c
// KAKAOSOFT Sound Driver
//
// Copyright (c) 2021 ڂ(@voich2014 in Twitter)
//
// Released under the MIT license.
// see https://opensource.org/licenses/MIT
// Where a citation is listed, please also check the license of the citing source.
//

#include "ksd.h"

//---------------------------------------------------------------------------
// 萔E}N` 
//---------------------------------------------------------------------------
#define PULSE1CTR1   (*(char*)0x4000)   	//`g1䃌WX^1
#define PULSE1CTR2   (*(char*)0x4001)   	//`g1䃌WX^2
#define PULSE1FREQ1  (*(char*)0x4002)   	//`g1gWX^1
#define PULSE1FREQ2  (*(char*)0x4003)   	//`g1gWX^2
#define PULSE2CTR1   (*(char*)0x4004)   	//`g2䃌WX^1
#define PULSE2CTR2   (*(char*)0x4005)   	//`g2䃌WX^2
#define PULSE2FREQ1  (*(char*)0x4006)   	//`g2gWX^1
#define PULSE2FREQ2  (*(char*)0x4007)   	//`g2gWX^2
#define TRIWCTRL     (*(char*)0x4008)   	//Opg䃌WX^
#define TRIWFREQ1    (*(char*)0x400A)   	//OpggWX^1
#define TRIWFREQ2    (*(char*)0x400B)   	//OpggWX^2
#define NOISECTRL    (*(char*)0x400C)   	//mCY䃌WX^
#define NOISERND     (*(char*)0x400E)   	//mCYWX^
#define NOISETIME    (*(char*)0x400F)   	//mCYԃWX^
#define SNDCHANNEL   (*(char*)0x4015)		//TEh`l

#define PULSE_HZ(hz) (((1790000/16)/hz)-1)	//`g̎gݒlvZ}N
#define TRI_HZ(hz)   (1790000/((hz+1)*32))	//Opg̎gݒlvZ}N

#define NOTE_MIN     (12)					//Lȉ̍ŏMIDIm[gԍ
#define NOTE_MAX     (119)					//Lȉ̍őMIDIm[gԍ
#define NOTE_O4A     (69)					//`gŃru[g␳o4ãm[gԍ
#define NOTE_O3A     (57)					//OpgŃru[g␳o3ãm[gԍ

#define DEF_DECAYQ   (1)					//Gx[v^C~Ol(QR}hl)̏l
#define DEF_VIBDELAY (40)					//ru[gfBC(VDR}hl)̏l
#define DEF_VIBMOD   (1)					//ru[gJE^(VMR}hl)̏l
#define DEF_VIBINT   (4)					//ru[ggω(VIR}hl)̏l
#define DEF_VIBSTEP  (1)					//ru[ggl(VSR}hl)̏l

//---------------------------------------------------------------------------
// O[oϐ 
//---------------------------------------------------------------------------
//[y[WɔzuO[oϐ
extern unsigned char* g_ch1_ptr;		//BGMpCH1(`g1)̃f[^|C^
extern unsigned char  g_ch1_cnt;		//BGMpCH1(`g1)̍ĐJE^
extern unsigned char  g_ch1_env;		//BGMpCH1(`g1)̃Gx[vLtO
extern unsigned char  g_ch1_vibcnt;		//BGMpCH1(`g1)̃ru[gJE^(1ȏŗL)
extern unsigned char  g_ch1_vibadd;		//BGMpCH1(`g1)̃ru[ggZl
extern unsigned char  g_ch1_vibdelay;	//BGMpCH1(`g1)ru[gfBC(VDR}hl)
extern unsigned char  g_ch1_vibmod;		//BGMpCH1(`g1)ru[gJE^(VMR}hl)
extern unsigned char  g_ch1_vibint;		//BGMpCH1(`g1)ru[ggω(VIR}hl)
extern unsigned char  g_ch1_vibstep;	//BGMpCH1(`g1)ru[ggl(VSR}hl)
extern unsigned char  g_ch1_decayQ;		//BGMpCH1(`g1)Gx[v^C~Ol(QR}hl)
extern unsigned char* g_ch2_ptr;		//BGMpCH2(Opg)̃f[^|C^
extern unsigned char  g_ch2_cnt;		//BGMpCH2(Opg)̍ĐJE^
extern unsigned char  g_ch2_env;		//BGMpCH2(Opg)̃Gx[vLtO
extern unsigned char  g_ch2_vibcnt;		//BGMpCH2(Opg)̃ru[gJE^(1ȏŗL)
extern unsigned char  g_ch2_vibadd;		//BGMpCH2(Opg)̃ru[ggZl
extern unsigned char  g_ch2_vibdelay;	//BGMpCH2(Opg)ru[gfBC(VDR}hl)
extern unsigned char  g_ch2_vibmod;		//BGMpCH2(Opg)ru[gJE^(VMR}hl)
extern unsigned char  g_ch2_vibint;		//BGMpCH2(Opg)ru[ggω(VIR}hl)
extern unsigned char  g_ch2_vibstep;	//BGMpCH2(Opg)ru[ggl(VSR}hl)
extern unsigned char  g_ch2_decayQ;		//BGMpCH2(Opg)Gx[v^C~Ol(QR}hl)
extern unsigned char* g_ch3_ptr;		//SEpCH3(`g2)̃f[^|C^
extern unsigned char  g_ch3_cnt;		//SEpCH3(`g2)̍ĐJE^
extern unsigned char  g_ch3_env;		//SEpCH3(`g2)̃Gx[vLtO
extern unsigned char  g_ch3_vibcnt;		//SEpCH3(`g2)̃ru[gJE^(1ȏŗL)
extern unsigned char  g_ch3_vibadd;		//SEpCH3(`g2)̃ru[ggZl
extern unsigned char  g_ch3_vibdelay;	//SEpCH3(`g2)ru[gfBC(VDR}hl)
extern unsigned char  g_ch3_vibmod;		//SEpCH3(`g2)ru[gJE^(VMR}hl)
extern unsigned char  g_ch3_vibint;		//SEpCH3(`g2)ru[ggω(VIR}hl)
extern unsigned char  g_ch3_vibstep;	//SEpCH3(`g2)ru[ggl(VSR}hl)
extern unsigned char  g_ch3_decayQ;		//SEpCH3(`g2)Gx[v^C~Ol(QR}hl)
extern unsigned char* g_ch4_ptr;		//SEpCH4(mCY)̃f[^|C^
extern unsigned char  g_ch4_cnt;		//SEpCH4(mCY)̍ĐJE^
extern unsigned char  g_ch4_env;		//SEpCH4(mCY)̃Gx[vLtO
extern unsigned char  g_ch4_vibcnt;		//SEpCH4(mCY)̃ru[gJE^(1ȏŗL)
extern unsigned char  g_ch4_vibadd;		//SEpCH4(mCY)̃ru[ggZl
extern unsigned char  g_ch4_vibdelay;	//SEpCH4(mCY)ru[gfBC(VDR}hl)
extern unsigned char  g_ch4_vibmod;		//SEpCH4(mCY)ru[gJE^(VMR}hl)
extern unsigned char  g_ch4_vibint;		//SEpCH4(mCY)ru[ggω(VIR}hl)
extern unsigned char  g_ch4_vibstep;	//SEpCH4(mCY)ru[ggl(VSR}hl)
extern unsigned char  g_ch4_decayQ;		//SEpCH4(mCY)Gx[v^C~Ol(QR}hl)

extern unsigned char  g_ch1_ctrl1;		//CH1(`g1)䃌WX^1̕ێl
extern unsigned char  g_ch1_ctrl2;		//CH1(`g1)䃌WX^2̕ێl
extern unsigned char  g_ch1_freq1;		//CH1(`g1)gWX^1̕ێl
extern unsigned char  g_ch1_freq2;		//CH1(`g1)gWX^2̕ێl
extern unsigned char  g_ch1_volset;		//CH1(`g1){[wl
extern unsigned short g_ch1_decay_step;	//CH1(`g1)(8:8bitŒ菬)
extern unsigned short g_ch1_decay_acc;	//CH1(`g1)~όl(8:8bitŒ菬)
extern unsigned char  g_ch1_vibstart;	//CH1(`g1)ru[gJn^C~O
extern unsigned char  g_ch2_ctrl;		//CH2(Opg)䃌WX^̕ێl
extern unsigned char  g_ch2_freq1;		//CH2(Opg)gWX^1̕ێl
extern unsigned char  g_ch2_freq2;		//CH2(Opg)gWX^2̕ێl
extern unsigned char  g_ch2_decay;		//CH2(Opg)^C~O
extern unsigned char  g_ch2_vibstart;	//CH2(Opg)ru[gJn^C~O
extern unsigned char  g_ch3_ctrl1;		//CH3(`g2)䃌WX^1̕ێl
extern unsigned char  g_ch3_ctrl2;		//CH3(`g2)䃌WX^2̕ێl
extern unsigned char  g_ch3_freq1;		//CH3(`g2)gWX^1̕ێl
extern unsigned char  g_ch3_freq2;		//CH3(`g2)gWX^2̕ێl
extern unsigned char  g_ch3_volset;		//CH3(`g2){[wl
extern unsigned short g_ch3_decay_step;	//CH3(`g2)(8:8bitŒ菬)
extern unsigned short g_ch3_decay_acc;	//CH3(`g2)~όl(8:8bitŒ菬)
extern unsigned char  g_ch3_vibstart;	//CH3(`g2)ru[gJn^C~O
extern unsigned char  g_ch4_ctrl;		//CH4(mCY)䃌WX^̕ێl
extern unsigned char  g_ch4_time;		//CH4(mCY)ԃWX^̕ێl
extern unsigned char  g_ch4_volset;		//CH4(mCY){[wl
extern unsigned short g_ch4_decay_step;	//CH4(mCY)(8:8bitŒ菬)
extern unsigned short g_ch4_decay_acc;	//CH4(mCY)~όl(8:8bitŒ菬)
extern unsigned char  g_ch4_vibstart;	//CH4(mCY)ru[gJn^C~O

extern unsigned char   g_snd_cmd;
extern unsigned char   g_snd_param_byte;
extern unsigned char   g_snd_param_byte2;
extern unsigned short  g_snd_param_word;
extern unsigned short  g_snd_param_word2;

#pragma zpsym ("g_ch1_ptr");
#pragma zpsym ("g_ch1_cnt");
#pragma zpsym ("g_ch1_env");
#pragma zpsym ("g_ch1_vibcnt");
#pragma zpsym ("g_ch1_vibadd");
#pragma zpsym ("g_ch1_vibdelay");
#pragma zpsym ("g_ch1_vibmod");
#pragma zpsym ("g_ch1_vibint");
#pragma zpsym ("g_ch1_vibstep");
#pragma zpsym ("g_ch1_decayQ");
#pragma zpsym ("g_ch2_ptr");
#pragma zpsym ("g_ch2_cnt");
#pragma zpsym ("g_ch2_env");
#pragma zpsym ("g_ch2_vibcnt");
#pragma zpsym ("g_ch2_vibadd");
#pragma zpsym ("g_ch2_vibdelay");
#pragma zpsym ("g_ch2_vibmod");
#pragma zpsym ("g_ch2_vibint");
#pragma zpsym ("g_ch2_vibstep");
#pragma zpsym ("g_ch2_decayQ");
#pragma zpsym ("g_ch3_ptr");
#pragma zpsym ("g_ch3_cnt");
#pragma zpsym ("g_ch3_env");
#pragma zpsym ("g_ch3_vibcnt");
#pragma zpsym ("g_ch3_vibadd");
#pragma zpsym ("g_ch3_vibdelay");
#pragma zpsym ("g_ch3_vibmod");
#pragma zpsym ("g_ch3_vibint");
#pragma zpsym ("g_ch3_vibstep");
#pragma zpsym ("g_ch3_decayQ");
#pragma zpsym ("g_ch4_ptr");
#pragma zpsym ("g_ch4_cnt");
#pragma zpsym ("g_ch4_env");
#pragma zpsym ("g_ch4_vibcnt");
#pragma zpsym ("g_ch4_vibadd");
#pragma zpsym ("g_ch4_vibdelay");
#pragma zpsym ("g_ch4_vibmod");
#pragma zpsym ("g_ch4_vibint");
#pragma zpsym ("g_ch4_vibstep");
#pragma zpsym ("g_ch4_decayQ");

#pragma zpsym ("g_ch1_ctrl1");
#pragma zpsym ("g_ch1_ctrl2");
#pragma zpsym ("g_ch1_freq1");
#pragma zpsym ("g_ch1_freq2");
#pragma zpsym ("g_ch1_volset");
#pragma zpsym ("g_ch1_decay_step");
#pragma zpsym ("g_ch1_decay_acc");
#pragma zpsym ("g_ch1_vibstart");
#pragma zpsym ("g_ch2_ctrl");
#pragma zpsym ("g_ch2_freq1");
#pragma zpsym ("g_ch2_freq2");
#pragma zpsym ("g_ch2_decay");
#pragma zpsym ("g_ch2_vibstart");
#pragma zpsym ("g_ch3_ctrl1");
#pragma zpsym ("g_ch3_ctrl2");
#pragma zpsym ("g_ch3_freq1");
#pragma zpsym ("g_ch3_freq2");
#pragma zpsym ("g_ch3_volset");
#pragma zpsym ("g_ch3_decay_step");
#pragma zpsym ("g_ch3_decay_acc");
#pragma zpsym ("g_ch3_vibstart");
#pragma zpsym ("g_ch4_ctrl");
#pragma zpsym ("g_ch4_time");
#pragma zpsym ("g_ch4_volset");
#pragma zpsym ("g_ch4_decay_step");
#pragma zpsym ("g_ch4_decay_acc");
#pragma zpsym ("g_ch4_vibstart");

#pragma zpsym ("g_snd_cmd");
#pragma zpsym ("g_snd_param_byte");
#pragma zpsym ("g_snd_param_byte2");
#pragma zpsym ("g_snd_param_word");
#pragma zpsym ("g_snd_param_word2");


//`ggWX^1ϊe[u(MIDIm[gԍgݒl8bit)
const unsigned char g_aPulseFreqLTbl[] =
{
	0xB9,0x39,0xCE,0x78,0x35,0x05,0xE5,0xD5,0xD5,
	0xE3,0xFF,0x27,0x5C,0x9C,0xE7,0x3C,0x9A,0x02,
	0x72,0xEA,0x6A,0xF1,0x7F,0x13,0xAD,0x4D,0xF3,
	0x9D,0x4D,0x00,0xB8,0x75,0x35,0xF8,0xBF,0x89,
	0x56,0x26,0xF9,0xCE,0xA6,0x80,0x5C,0x3A,0x1A,
	0xFC,0xDF,0xC4,0xAB,0x93,0x7C,0x67,0x52,0x3F,
	0x2D,0x1C,0x0C,0xFD,0xEF,0xE2,0xD5,0xC9,0xBD,
	0xB3,0xA9,0x9F,0x96,0x8E,0x86,0x7E,0x77,0x70,
	0x6A,0x64,0x5E,0x59,0x54,0x4F,0x4B,0x46,0x42,
	0x3F,0x3B,0x38,0x34,0x31,0x2F,0x2C,0x29,0x27,
	0x25,0x23,0x21,0x1F,0x1D,0x1B,0x1A,0x18,0x17,
	0x15,0x14,0x13,0x12,0x11,0x10,0x0F,0x0E,0x0D
};

//`ggWX^2ϊe[u(MIDIm[gԍgݒl3bit)
const unsigned char g_aPulseFreqHTbl[] =
{
	0x1A,0x19,0x17,0x16,0x15,0x14,0x12,0x11,0x10,
	0x0F,0x0E,0x0E,0x0D,0x0C,0x0B,0x0B,0x0A,0x0A,
	0x09,0x08,0x08,0x07,0x07,0x07,0x06,0x06,0x05,
	0x05,0x05,0x05,0x04,0x04,0x04,0x03,0x03,0x03,
	0x03,0x03,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
	0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
	0x01,0x01,0x01,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};


//OpggWX^1ϊe[u(MIDIm[gԍgݒl8bit)
const unsigned char g_aTriangleFreqLTbl[] =
{
	0x98,0xED,0x4A,0xB0,0x1D,0x93,0x0F,0x92,0x1B,
	0xAB,0x40,0xDB,0x7C,0x21,0xCB,0x7A,0x2D,0xE5,
	0xA0,0x5F,0x21,0xE7,0xB0,0x7C,0x4A,0x1C,0xF0,
	0xC6,0x9F,0x79,0x56,0x35,0x16,0xF8,0xDC,0xC1,
	0xA8,0x91,0x7A,0x65,0x51,0x3F,0x2D,0x1C,0x0C,
	0xFD,0xEF,0xE2,0xD5,0xC9,0xBE,0xB3,0xA9,0xA0,
	0x97,0x8E,0x86,0x7F,0x78,0x71,0x6B,0x65,0x5F,
	0x5A,0x55,0x50,0x4B,0x47,0x43,0x3F,0x3C,0x39,
	0x35,0x32,0x30,0x2D,0x2A,0x28,0x26,0x24,0x22,
	0x20,0x1E,0x1C,0x1B,0x19,0x18,0x16,0x15,0x14,
	0x13,0x12,0x11,0x10,0x0F,0x0E,0x0D,0x0D,0x0C,
	0x0B,0x0B,0x0A,0x09,0x09,0x08,0x08,0x07,0x07
};

//OpggWX^2ϊe[u(MIDIm[gԍgݒl3bit)
const unsigned char g_aTriangleFreqHTbl[] =
{
	0x0C,0x0B,0x0B,0x0A,0x0A,0x09,0x09,0x08,0x08,
	0x07,0x07,0x06,0x06,0x06,0x05,0x05,0x05,0x04,
	0x04,0x04,0x04,0x03,0x03,0x03,0x03,0x03,0x02,
	0x02,0x02,0x02,0x02,0x02,0x02,0x01,0x01,0x01,
	0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};


//---------------------------------------------------------------------------
// TEhhCo֐ 
//---------------------------------------------------------------------------
void ksd_init(void)
{

	//TEhhCo
	
	//TEh֘AWX^S
	unsigned char enable_dpcm,enable_noise,enable_triangle,enable_pulse2,enable_pulse1;
	
	//`gCH1̃[NA
	PULSE1CTR1 = 0;
	PULSE1CTR2  = 0;
	PULSE1FREQ1 = 0;
	PULSE1FREQ2 = 0;
	
	//`gCH2̃[NA
	PULSE2CTR1  = 0;
	PULSE2CTR2  = 0;
	PULSE2FREQ1 = 0;
	PULSE2FREQ2 = 0;

	//Opg̃[NA
	TRIWCTRL    = 0;
	TRIWFREQ1   = 0;
	TRIWFREQ2   = 0;
	
	//mCỸ[NA
	NOISECTRL   = 0x30;		//ʃ[ɂ
	NOISERND    = 0;
	NOISETIME   = 0;
	
	
	//p`lw
	enable_dpcm     = 0;	//DPCML     (0:OFF 1:ON)
	enable_noise    = 1;	//mCYL   (0:OFF 1:ON)
	enable_triangle = 1;	//OpgchL (0:OFF 1:ON)
	enable_pulse2   = 1;	//`gch2L(0:OFF 1:ON)
	enable_pulse1   = 1;	//`gch1L(0:OFF 1:ON)
	
	SNDCHANNEL = (enable_dpcm<<4)+(enable_noise<<3)+(enable_triangle<<2)+
				 (enable_pulse2<<1)+enable_pulse1;
	
	//BGM/SEf[^̃NA
	g_ch1_ptr  = NULL;
	g_ch1_cnt  = 0;
	g_ch1_vol  = 0;
	g_ch1_note = 0;
	g_ch2_ptr  = NULL;
	g_ch2_cnt  = 0;
	g_ch2_vol  = 0;
	g_ch2_note = 0;
	g_ch3_ptr  = NULL;
	g_ch3_cnt  = 0;
	g_ch3_vol  = 0;
	g_ch3_note = 0;
	g_ch4_ptr  = NULL;
	g_ch4_cnt  = 0;
	g_ch4_vol  = 0;
	g_ch4_rnd  = 0;
	
}
//---------------------------------------------------------------------------
void ksd_play_bgm(void* bgm_data)
{

	//BGMĐo^
	unsigned char duty,enable_decayloop,disable_decay;
	unsigned char enable_sweep,period,freqdir,freqshift;
	
	//CH1WX^̏
	duty             = 0;	//f[eB 00: 2/14(12.5%) 01: 4/12(25.0%)
							//             10: 8/ 8(50.0%) 11:12/ 4(75.0%)
	enable_decayloop = 1;	//Gx[v[vL(0:OFF 1:ON)
	disable_decay    = 1;	//Gx[vDecay(0:L 1:)
	g_ch1_volset     = 15;	//Œ{[l 0 ` 15
	enable_sweep     = 0;	//gωL(0:OFF 1:ON)
	period           = 0;	//gω(0 ` 7)
	freqdir          = 0;	//gω(0:ႭȂ 1:Ȃ)
	freqshift        = 0;	//gω(0 ` 7)
	
	g_ch1_ctrl1 = (duty<<6)+(enable_decayloop<<5)+(disable_decay<<4)+g_ch1_volset;
	g_ch1_ctrl2 = (enable_sweep<<7)+(period<<4)+(freqdir<<3)+freqshift;
	g_ch1_note  = 0;
	g_ch1_freq1 = 0;
	g_ch1_freq2 = 0;
	
	PULSE1CTR1  = 0;
	PULSE1CTR2  = 0;
	
	
	//CH2WX^̏
	g_ch2_note  = 0;
	g_ch2_freq1 = 0;
	g_ch2_freq2 = 0;
	
	TRIWCTRL    = 0;
	TRIWFREQ1   = 0;
	TRIWFREQ2   = 0;
	
	
	//BGMf[^ݒ
	g_ch1_ptr      = ((unsigned char**)bgm_data)[0];
	g_ch1_cnt      = 0;
	g_ch1_env      = 0;
	g_ch1_vibcnt   = 0;
	g_ch1_vibadd   = 0;
	g_ch1_vibdelay = DEF_VIBDELAY;
	g_ch1_vibmod   = DEF_VIBMOD;
	g_ch1_vibint   = DEF_VIBINT;
	g_ch1_vibstep  = DEF_VIBSTEP;
	g_ch1_decayQ   = DEF_DECAYQ;

	g_ch2_ptr      = ((unsigned char**)bgm_data)[1];
	g_ch2_cnt      = 0;
	g_ch2_env      = 0;
	g_ch2_vibcnt   = 0;
	g_ch2_vibadd   = 0;
	g_ch2_vibdelay = DEF_VIBDELAY;
	g_ch2_vibmod   = DEF_VIBMOD;
	g_ch2_vibint   = DEF_VIBINT;
	g_ch2_vibstep  = DEF_VIBSTEP;
	g_ch2_decayQ   = DEF_DECAYQ;
	
}
//---------------------------------------------------------------------------
void ksd_stop_bgm(void)
{
	
	//BGM~
	
	//`gCH1̃[NA
	PULSE1CTR1  = 0;
	PULSE1CTR2  = 0;
	PULSE1FREQ1 = 0;
	PULSE1FREQ2 = 0;

	//Opg̃[NA
	TRIWCTRL    = 0;
	TRIWFREQ1   = 0;
	TRIWFREQ2   = 0;
	
	//BGMf[^̃NA
	g_ch1_ptr = NULL;
	g_ch1_cnt = 0;
	g_ch2_ptr = NULL;
	g_ch2_cnt = 0;

}
//---------------------------------------------------------------------------
void ksd_play_se1(void* se_data)
{

	//SE1(`g)Đo^
	unsigned char duty,enable_decayloop,disable_decay;
	unsigned char enable_sweep,period,freqdir,freqshift;

	//CH3WX^̏
	duty             = 0;	//f[eB 00: 2/14(12.5%) 01: 4/12(25.0%)
							//             10: 8/ 8(50.0%) 11:12/ 4(75.0%)
	enable_decayloop = 1;	//Gx[v[vL(0:OFF 1:ON)
	disable_decay    = 1;	//Gx[vDecay(0:L 1:)
	g_ch3_volset     = 15;	//Œ{[l 0 ` 15
	enable_sweep     = 0;	//gωL(0:OFF 1:ON)
	period           = 0;	//gω(0 ` 7)
	freqdir          = 0;	//gω(0:ႭȂ 1:Ȃ)
	freqshift        = 0;	//gω(0 ` 7)
	
	g_ch3_ctrl1 = (duty<<6)+(enable_decayloop<<5)+(disable_decay<<4)+g_ch3_volset;
	g_ch3_ctrl2 = (enable_sweep<<7)+(period<<4)+(freqdir<<3)+freqshift;
	g_ch3_note  = 0;
	g_ch3_freq1 = 0;
	g_ch3_freq2 = 0;
	
	PULSE2CTR1  = 0;
	PULSE2CTR2  = 0;
	
	
	//SEf[^ݒ
	g_ch3_ptr      = (unsigned char*)se_data;
	g_ch3_cnt      = 0;
	g_ch3_env      = 0;
	g_ch3_vibcnt   = 0;
	g_ch3_vibadd   = 0;
	g_ch3_vibdelay = DEF_VIBDELAY;
	g_ch3_vibmod   = DEF_VIBMOD;
	g_ch3_vibint   = DEF_VIBINT;
	g_ch3_vibstep  = DEF_VIBSTEP;
	g_ch3_decayQ   = DEF_DECAYQ;

}
//---------------------------------------------------------------------------
void ksd_stop_se1(void)
{

	//SE1(`g)~

	//`gCH2̃[NA
	PULSE2CTR1  = 0;
	PULSE2CTR2  = 0;
	PULSE2FREQ1 = 0;
	PULSE2FREQ2 = 0;
	
	//SEf[^̃NA
	g_ch3_ptr = NULL;
	g_ch3_cnt = 0;

}
//---------------------------------------------------------------------------
void ksd_play_se2(void* se_data)
{

	//SE2(mCY)Đo^
	unsigned char enable_decayloop,disable_decay;
	unsigned char rnd_type,noisefreq;
	
	//CH4WX^̏
	enable_decayloop = 1;	//Gx[v[vL(0:OFF 1:ON)
	disable_decay    = 1;	//Gx[vDecay(0:L 1:)
	g_ch4_volset     = 15;	//Œ{[l 0 ` 15
	rnd_type         = 0;	//^Cv(0:32kbit[h 1:93bit[h)
	noisefreq        = 0;	//mCYg(0 ` 15)
	
	g_ch4_ctrl = (enable_decayloop<<5)+(disable_decay<<4)+g_ch4_volset;
	g_ch4_rnd  = (rnd_type<<7)+noisefreq;
	
	NOISERND  = g_ch4_rnd;
	NOISETIME = 0;
	NOISECTRL = g_ch4_ctrl;		//ʐ䍞݂Ȃ̂ōŌɐݒ
	
	
	//SEf[^ݒ
	g_ch4_ptr      = (unsigned char*)se_data;
	g_ch4_cnt      = 0;
	g_ch4_env      = 0;
	g_ch4_vibcnt   = 0;
	g_ch4_vibadd   = 0;
	g_ch4_vibdelay = DEF_VIBDELAY;
	g_ch4_vibmod   = DEF_VIBMOD;
	g_ch4_vibint   = DEF_VIBINT;
	g_ch4_vibstep  = DEF_VIBSTEP;
	g_ch4_decayQ   = DEF_DECAYQ;
	
}
//---------------------------------------------------------------------------
void ksd_stop_se2(void)
{

	//SE2(mCY)~

	//mCỸ[NA
	NOISECTRL   = 0x30;		//ʃ[ɂ
	NOISERND    = 0;
	NOISETIME   = 0;
	
	//SEf[^̃NA
	g_ch4_ptr = NULL;
	g_ch4_cnt = 0;

}
//---------------------------------------------------------------------------
void ksd_mainproc(void)
{

	//TEhhCoC
	
	//
	// ɏ肷4ch̃TEhforŉ񂷂
	// svȔrĎԂĂ܂̂ŁAforɂɁA
	// x^ɓWJĕKvȏĂ܂B
	// 
	// ܂Aϐ𗘗pƃX^bN𗘗pẴWX^
	// 肭肪nes.libɊ܂܂Tu[`ĂяočsA
	// rITCN̑JSR/RTS߂pɂɎg悤
	// ɂȂ̂ŁA[y[WɒuO[oϐėpϐƂ
	// pāAʂȃTu[`ĂяoȂĂ܂B
	//
	// TEh̒ŎԂĂ̂́AGx[v̌
	// ʂŒ菭ŌvZ镔ƁAru[g̏]Zŕ
	// ɂȂ܂B
	// Ał悤ɂĂłB
	//
	
	//======================================================
	// ch1 `g
	//======================================================
	if(g_ch1_ptr != (unsigned char*)NULL)
	{
		while(1)
		{
			if(g_ch1_cnt == 0)
			{
				//ĐJEg0ɂȂ
				//̃R}hǂ
				g_snd_cmd = (*g_ch1_ptr);
				g_ch1_ptr++;
				
				switch(g_snd_cmd)
				{
					case KSD_CH1_TONE1:
						
						//CH1F1ɐ؂ւ
						
						//f[eB00: 2/14(12.5%)ɐݒ
						g_ch1_ctrl1 &= ~0xC0;
						//g_ch1_ctrl1 |= (0<<6);//0Ȃ̂Őݒsv
						
						PULSE1CTR1 = g_ch1_ctrl1;

						break;
					
					case KSD_CH1_TONE2:

						//CH1F2ɐ؂ւ
						
						//f[eB01: 4/12(25%)ɐݒ
						g_ch1_ctrl1 &= ~0xC0;
						g_ch1_ctrl1 |= 0x40;	//0x40 = (1<<6)
						
						PULSE1CTR1 = g_ch1_ctrl1;

						break;
					
					case KSD_CH1_TONE3:

						//CH1F3ɐ؂ւ
						
						//f[eB10: 8/ 8(50%)ɐݒ
						g_ch1_ctrl1 &= ~0xC0;
						g_ch1_ctrl1 |= 0x80;	//0x80 = (2<<6)
						
						PULSE1CTR1 = g_ch1_ctrl1;

						break;
					
					case KSD_CH1_NOTE:

						//CH1̃m[gԍw
						
						//m[gԍ擾
						g_ch1_note = (*g_ch1_ptr);
						g_ch1_ptr++;
						
						//gWX^l擾
						//g_snd_param_byte = g_ch1_note - NOTE_MIN;		//ƒx̂łȂ
						g_snd_param_byte  = g_ch1_note;
						g_snd_param_byte -= NOTE_MIN;
						g_ch1_freq1       = g_aPulseFreqLTbl[g_snd_param_byte];
						g_ch1_freq2       = g_aPulseFreqHTbl[g_snd_param_byte];
						
						//WX^ɐݒ
						PULSE1FREQ1 = g_ch1_freq1;
						PULSE1FREQ2 = g_ch1_freq2;
						
						//{[ێlZbg
						g_ch1_vol    = g_ch1_volset;
						g_ch1_ctrl1 &= ~0x0F;
						g_ch1_ctrl1 |= g_ch1_vol;
						
						//WX^ɐݒ
						PULSE1CTR1 = g_ch1_ctrl1;

						break;
					
					case KSD_CH1_CNT:

						//CH1̍ĐJE^w
						
						//ĐJE^l擾
						g_snd_param_byte = (*g_ch1_ptr);
						g_ch1_ptr++;
						
						//1t[Ƃ̉ʌŒ菬ŌvZ
						if(g_ch1_env)
						{
							g_snd_param_word  = ((unsigned short)g_ch1_vol << 8);	//vol
							g_snd_param_word2 = g_snd_param_byte;					//len
							if(g_ch1_decayQ > 1)
							{	g_snd_param_word2 -= (g_snd_param_byte / g_ch1_decayQ);	}
							g_ch1_decay_step = (g_snd_param_word+(g_snd_param_word2>>1)) / g_snd_param_word2;	//ľܓ
							g_ch1_decay_acc  = 0;
						}
						
						//ێlɍXV
						g_ch1_cnt = g_snd_param_byte;
						
						if(g_ch1_vibcnt > 0)
						{
							//ru[gJn^C~Oݒ
							if(g_ch1_vibdelay >= g_snd_param_byte)
							{	 g_ch1_vibstart = 0;	}
							else
							{	g_ch1_vibstart = g_snd_param_byte - g_ch1_vibdelay;	}
						
							//ru[g֘AZbg
							g_ch1_vibadd = g_ch1_vibstep;
							if(g_ch1_note == NOTE_O4A)
							{
								//o4a(0xFD)̓ru[gŌ̎g𒴂Ȃ悤ɂ
								//ibitωƃL[IăMMmCYɂȂ邽߁j
								g_ch1_vibcnt = 1;
							}
							else
							{
								//̉͌̎g𒆐Sɂď㉺
								g_ch1_vibcnt = 1 + (g_ch1_vibint >> 1);
							}
						}

						break;
					
					case KSD_CH1_VOL:

						//CH1̃{[lݒ
						
						//{[l擾
						g_ch1_volset = (*g_ch1_ptr) & 0x0F;
						g_ch1_ptr++;

						break;
					
					case KSD_CH1_DECAYQ:

						//Gx[v^C~Ow
						
						//QR}hl
						g_snd_param_byte = (*g_ch1_ptr);
						g_ch1_ptr++;
						
						//ێlɍXV
						g_ch1_decayQ = g_snd_param_byte;

						break;
					
					case KSD_CH1_VIBDELAY:

						//ru[gfBCw
						
						//VDR}hl
						g_snd_param_byte = (*g_ch1_ptr);
						g_ch1_ptr++;
						
						//ێlɍXV
						g_ch1_vibdelay = g_snd_param_byte;

						break;
				
					case KSD_CH1_VIBMOD:

						//ru[gJE^w
						
						//VMR}hl
						g_snd_param_byte = (*g_ch1_ptr);
						g_ch1_ptr++;
						
						//ێlɍXV
						g_ch1_vibmod = g_snd_param_byte;

						break;
					
					case KSD_CH1_VIBINTERVAL:

						//ru[ggωw
						
						//VIR}hl
						g_snd_param_byte = (*g_ch1_ptr);
						g_ch1_ptr++;
						
						//ێlɍXV
						g_ch1_vibint = g_snd_param_byte;

						break;
					
					case KSD_CH1_VIBSTEP:

						//ru[gglw
						
						//VSR}hl
						g_snd_param_byte = (*g_ch1_ptr);
						g_ch1_ptr++;
						
						//ێlɍXV
						g_ch1_vibstep = g_snd_param_byte;

						break;
					
					case KSD_ENV_ON:

						//Gx[vL
						g_ch1_env = 1;

						break;
					
					case KSD_ENV_OFF:

						//Gx[v
						g_ch1_env = 0;

						break;
					
					case KSD_VIB_ON:

						//ru[gL
						g_ch1_vibcnt = 1;

						break;
					
					case KSD_VIB_OFF:

						//ru[g
						g_ch1_vibcnt = 0;

						break;
					
					case KSD_CH1_REST:

						//CH1̋xw
						
						//擾
						g_snd_param_byte = (*g_ch1_ptr);
						g_ch1_ptr++;
						
						//ĐJE^ێlɔf
						g_ch1_cnt = g_snd_param_byte;
						
						//ʌNA
						g_ch1_decay_step = 0;
						g_ch1_decay_acc  = 0;
						
						//{[ێlZbg
						g_ch1_vol    = 0;
						g_ch1_ctrl1 &= ~0x0F;
						g_ch1_ctrl1 |= g_ch1_vol;
						
						//WX^ɐݒ
						PULSE1CTR1 = g_ch1_ctrl1;

						break;
					
					case KSD_LOOP:

						//ItZbg擾čĐf[^|C^߂
						
						g_snd_param_word  = (*g_ch1_ptr) << 8;
						g_ch1_ptr++;
						g_snd_param_word |= (*g_ch1_ptr);
						g_ch1_ptr++;
						
						g_ch1_ptr -= g_snd_param_word;

						break;
					
					case KSD_END:

						//Đ~
						g_ch1_ptr = NULL;
						g_ch1_cnt = 0;
						goto ch1exit;

						break;
					
					default:

						//mȂR}hI
						ksd_init();
						goto ch1exit;

						break;
				}
			}
			else
			{
				//ĐJEg
				g_ch1_cnt--;
				
				//
				if(g_ch1_env)	//Gx[vLɑ
				{
					//̃t[ł̉ʌZ
					g_ch1_decay_acc += g_ch1_decay_step;
					g_snd_param_byte = (g_ch1_decay_acc >> 8);
					
					//ʂ̌
					if(g_ch1_vol > 0)
					{
						if(g_ch1_vol < g_snd_param_byte)
						{
							//ɂ
							g_ch1_vol = 0;
							g_ch1_ctrl1 &= ~0x0F;
							
							//WX^ɐݒ
							PULSE1CTR1 = g_ch1_ctrl1;
						}
						else if(g_snd_param_byte > 0)
						{
							//ێlɔf
							g_ch1_vol -= g_snd_param_byte;
							g_ch1_ctrl1 &= ~0x0F;
							g_ch1_ctrl1 |= g_ch1_vol;
							
							//WX^ɐݒ
							PULSE1CTR1 = g_ch1_ctrl1;
							
							//~ϒlXV
							g_ch1_decay_acc &= 0x00FF;
						}
					}
				}
				
				//ru[g
				if(g_ch1_vibcnt > 0)
				{
					if((g_ch1_cnt % g_ch1_vibmod) == 0)
					{
						if(g_ch1_cnt <= g_ch1_vibstart)
						{
							//ru[ĝ߂̎gύX
							
							//ZlƂĂ܂AgƂ납
							//n߂̂ňZɂĂ܂
							g_ch1_freq1 -= g_ch1_vibadd;
							
							PULSE1FREQ1 = g_ch1_freq1;

							//ru[g̎gωؑ
							if(g_ch1_vibcnt == g_ch1_vibint)
							{
								g_ch1_vibadd = 0xFF - g_ch1_vibadd + 1;		//](2̕␔\)
								g_ch1_vibcnt  = 1;		//0ɂƃru[gOFFɂȂ̂1ɂ܂
							}
							else
							{	g_ch1_vibcnt++;	}
						}
					}
				}
				break;
			}
		}
ch1exit:;
	}
	
	//======================================================
	// ch2 Opg
	//======================================================
	if(g_ch2_ptr != (unsigned char*)NULL)
	{
		while(1)
		{
			if(g_ch2_cnt == 0)
			{
				//ĐJEg0ɂȂ
				//̃R}hǂ
				g_snd_cmd = (*g_ch2_ptr);
				g_ch2_ptr++;
				
				switch(g_snd_cmd)
				{
#if 0
					case KSD_CH2_TONE1:
					case KSD_CH2_TONE2:
					
						//Opg̉F̓ru[gON/OFFȂ̂
						//ɉ܂
						
						break;
#endif
					
					case KSD_CH2_NOTE:
					
						//CH2̃m[gԍw
						
						//m[gԍ擾
						g_ch2_note = (*g_ch2_ptr);
						g_ch2_ptr++;
						
						//gWX^l擾
						//g_snd_param_byte = g_ch2_note - NOTE_MIN;		//ƒx̂łȂ
						g_snd_param_byte  = g_ch2_note;
						g_snd_param_byte -= NOTE_MIN;
						g_ch2_freq1       = g_aTriangleFreqLTbl[g_snd_param_byte];
						g_ch2_freq2       = g_aTriangleFreqHTbl[g_snd_param_byte];
						
						//WX^ɐݒ
						TRIWCTRL  = 0x81;			//ƁAȂƖ
						TRIWFREQ1 = g_ch2_freq1;
						TRIWFREQ2 = g_ch2_freq2;
						
						//{[ێlZbg
						g_ch2_vol = 0x0F;
						
						break;
					
					case KSD_CH2_CNT:
					
						//CH2̍ĐJE^w
						
						//ĐJE^l擾
						g_snd_param_byte = (*g_ch2_ptr);
						g_ch2_ptr++;
						
						//ێlɍXV
						g_ch2_cnt = g_snd_param_byte;
						
						//^C~Oݒ
						if(g_ch2_env)
						{
							if(g_snd_param_byte <= 8)
							{	g_ch2_decay = g_snd_param_byte - 1;	}
							else
							{	g_ch2_decay = 8;			}
						}
						
						if(g_ch2_vibcnt > 0)
						{
							//ru[gJn^C~Oݒ
							if(g_ch2_vibdelay >= g_snd_param_byte)
							{	 g_ch2_vibstart = 0;	}
							else
							{	g_ch2_vibstart = g_snd_param_byte - g_ch2_vibdelay;	}
						
							//ru[g֘AZbg
							g_ch2_vibadd = g_ch2_vibstep;
							if(g_ch2_note == NOTE_O3A)
							{
								//o3a(0xFD)̓ru[gŌ̎g𒴂Ȃ悤ɂ
								//ibitωƃL[IăMMmCYɂȂ邽߁j
								g_ch2_vibcnt = 1;
							}
							else
							{
								//̉͌̎g𒆐Sɂď㉺
								g_ch2_vibcnt = 1 + (g_ch2_vibint >> 1);
							}
						}
						
						break;
						
					case KSD_CH2_VIBDELAY:
					
						//ru[gfBCw
						
						//VDR}hl
						g_snd_param_byte = (*g_ch2_ptr);
						g_ch2_ptr++;
						
						//ێlɍXV
						g_ch2_vibdelay = g_snd_param_byte;
						
						break;
						
					case KSD_CH2_VIBMOD:

						//ru[gJE^w
						
						//VMR}hl
						g_snd_param_byte = (*g_ch2_ptr);
						g_ch2_ptr++;
						
						//ێlɍXV
						g_ch2_vibmod = g_snd_param_byte;
						
						break;
						
					case KSD_CH2_VIBINTERVAL:

						//ru[ggωw
						
						//VIR}hl
						g_snd_param_byte = (*g_ch2_ptr);
						g_ch2_ptr++;
						
						//ێlɍXV
						g_ch2_vibint = g_snd_param_byte;
						
						break;
						
					case KSD_CH2_VIBSTEP:

						//ru[gglw
						
						//VSR}hl
						g_snd_param_byte = (*g_ch2_ptr);
						g_ch2_ptr++;
						
						//ێlɍXV
						g_ch2_vibstep = g_snd_param_byte;
						
						break;
						
					case KSD_ENV_ON:
					
						//Gx[vL
						g_ch2_env = 1;
						
						break;
						
					case KSD_ENV_OFF:

						//Gx[v
						g_ch2_env = 0;
						
						break;
						
					case KSD_VIB_ON:

						//ru[gL
						g_ch2_vibcnt = 1;
						
						break;
						
					case KSD_VIB_OFF:

						//ru[g
						g_ch2_vibcnt = 0;
						
						break;
						
					case KSD_CH2_REST:

						//CH2̋xw
						
						//擾
						g_snd_param_byte = (*g_ch2_ptr);
						g_ch2_ptr++;
						
						//ێlɍXV
						g_ch2_cnt = g_snd_param_byte;
						
						//ʌ^C~ONA
						g_ch2_decay = 0;
						
						//ĐJE^ɃjAJE^[ɐݒ
						TRIWCTRL  = 0x80;
						
						//{[ێlZbg
						g_ch2_vol = 0x00;
						
						break;
						
					case KSD_LOOP:

						//ItZbg擾čĐf[^|C^߂
						
						g_snd_param_word  = (*g_ch2_ptr) << 8;
						g_ch2_ptr++;
						g_snd_param_word |= (*g_ch2_ptr);
						g_ch2_ptr++;
						
						g_ch2_ptr -= g_snd_param_word;
						
						break;
						
					case KSD_END:

						//Đ~
						g_ch2_ptr = NULL;
						g_ch2_cnt = 0;
						goto ch2exit;
						
						break;
				
					default:
					
						//mȂR}hI
						ksd_init();
						goto ch2exit;
						
						break;
				}
			}
			else
			{
				//ĐJEg
				g_ch2_cnt--;
				
				//
				if(g_ch2_env)	//Gx[vLɑ
				{
					if(g_ch2_cnt == g_ch2_decay)
					{
						//ZďI悤ɂ
						TRIWCTRL  = 0x20;
						
						//{[ێlZbg
						g_ch2_vol = 0x00;
					}
				}
				
				//ru[g
				if(g_ch2_vibcnt > 0)
				{
					if((g_ch2_cnt % g_ch2_vibmod) == 0)
					{
						if(g_ch2_cnt <= g_ch2_vibstart)
						{
							//ru[ĝ߂̎gύX
							
							//ZlƂĂ܂AgƂ납
							//n߂̂ňZɂĂ܂
							g_ch2_freq1 -= g_ch2_vibadd;
							
							TRIWFREQ1 = g_ch2_freq1;
							
							//ru[g̎gωؑ
							if(g_ch2_vibcnt == g_ch2_vibint)
							{
								g_ch2_vibadd = 0xFF - g_ch2_vibadd + 1;		//](2̕␔\)
								g_ch2_vibcnt  = 1;		//0ɂƃru[gOFFɂȂ̂1ɂ܂
							}
							else
							{	g_ch2_vibcnt++;	}
						}
					}
				}
				break;
			}
		}
ch2exit:;
	}
	
	//======================================================
	// ch3 `g
	//======================================================
	if(g_ch3_ptr != (unsigned char*)NULL)
	{
		while(1)
		{
			if(g_ch3_cnt == 0)
			{
				//ĐJEg0ɂȂ
				//̃R}hǂ
				g_snd_cmd = (*g_ch3_ptr);
				g_ch3_ptr++;
				
				switch(g_snd_cmd)
				{
					case KSD_CH3_TONE1:

						//CH3F1ɐ؂ւ
						
						//f[eB00: 2/14(12.5%)ɐݒ
						g_ch3_ctrl1 &= ~0xC0;
						//g_ch3_ctrl1 |= (0<<6);//0Ȃ̂Őݒsv
						
						PULSE2CTR1 = g_ch3_ctrl1;
						
						break;
						
					case KSD_CH3_TONE2:

						//CH3F2ɐ؂ւ
						
						//f[eB01: 4/12(25%)ɐݒ
						g_ch3_ctrl1 &= ~0xC0;
						g_ch3_ctrl1 |= 0x40;	//0x40 = (1<<6)
						
						PULSE2CTR1 = g_ch3_ctrl1;
						
						break;
						
					case KSD_CH3_TONE3:

						//CH3F3ɐ؂ւ
						
						//f[eB10: 8/ 8(50%)ɐݒ
						g_ch3_ctrl1 &= ~0xC0;
						g_ch3_ctrl1 |= 0x80;	//0x80 = (2<<6)
						
						PULSE2CTR1 = g_ch3_ctrl1;
						
						break;
						
					case KSD_CH3_NOTE:

						//CH3̃m[gԍw
						
						//m[gԍ擾
						g_ch3_note = (*g_ch3_ptr);
						g_ch3_ptr++;
						
						//gWX^l擾
						//g_snd_param_byte = g_ch3_note - NOTE_MIN;		//ƒx̂łȂ
						g_snd_param_byte  = g_ch3_note;
						g_snd_param_byte -= NOTE_MIN;
						g_ch3_freq1       = g_aPulseFreqLTbl[g_snd_param_byte];
						g_ch3_freq2       = g_aPulseFreqHTbl[g_snd_param_byte];
					
						//WX^ɐݒ
						PULSE2FREQ1 = g_ch3_freq1;
						PULSE2FREQ2 = g_ch3_freq2;
						
						//{[ێlZbg
						g_ch3_vol    = g_ch3_volset;
						g_ch3_ctrl1 &= ~0x0F;
						g_ch3_ctrl1 |= g_ch3_vol;
						
						//WX^ɐݒ
						PULSE2CTR1 = g_ch3_ctrl1;
						
						break;
						
					case KSD_CH3_CNT:

						//CH3̍ĐJE^w
						
						//ĐJE^l擾
						g_snd_param_byte = (*g_ch3_ptr);
						g_ch3_ptr++;
						
						//1t[Ƃ̉ʌŒ菬ŌvZ
						if(g_ch3_env)
						{
							g_snd_param_word  = ((unsigned short)g_ch3_vol << 8);	//vol
							g_snd_param_word2 = g_snd_param_byte;					//len
							if(g_ch3_decayQ > 1)
							{	g_snd_param_word2 -= (g_snd_param_byte / g_ch3_decayQ);	}
							g_ch3_decay_step = (g_snd_param_word+(g_snd_param_word2>>1)) / g_snd_param_word2;	//ľܓ
							g_ch3_decay_acc  = 0;
						}
						
						//ێlɍXV
						g_ch3_cnt = g_snd_param_byte;
						
						if(g_ch3_vibcnt > 0)
						{
							//ru[gJn^C~Oݒ
							if(g_ch3_vibdelay >= g_snd_param_byte)
							{	 g_ch3_vibstart = 0;	}
							else
							{	g_ch3_vibstart = g_snd_param_byte - g_ch3_vibdelay;	}
						
							//ru[g֘AZbg
							g_ch3_vibadd = g_ch3_vibstep;
							if(g_ch3_note == NOTE_O4A)
							{
								//o4a(0xFD)̓ru[gŌ̎g𒴂Ȃ悤ɂ
								//ibitωƃL[IăMMmCYɂȂ邽߁j
								g_ch3_vibcnt = 1;
							}
							else
							{
								//̉͌̎g𒆐Sɂď㉺
								g_ch3_vibcnt = 1 + (g_ch3_vibint >> 1);
							}
						}
						
						break;
						
					case KSD_CH3_VOL:

						//CH3̃{[lݒ
						
						//{[l擾
						g_ch3_volset = (*g_ch3_ptr) & 0x0F;
						g_ch3_ptr++;
						
						break;
						
					case KSD_CH3_DECAYQ:

						//Gx[v^C~Ow
						
						//QR}hl
						g_snd_param_byte = (*g_ch3_ptr);
						g_ch3_ptr++;
						
						//ێlɍXV
						g_ch3_decayQ = g_snd_param_byte;
						
						break;
						
					case KSD_CH3_VIBDELAY:

						//ru[gfBCw
						
						//VDR}hl
						g_snd_param_byte = (*g_ch3_ptr);
						g_ch3_ptr++;
						
						//ێlɍXV
						g_ch3_vibdelay = g_snd_param_byte;
						
						break;
						
					case KSD_CH3_VIBMOD:

						//ru[gJE^w
						
						//VMR}hl
						g_snd_param_byte = (*g_ch3_ptr);
						g_ch3_ptr++;
						
						//ێlɍXV
						g_ch3_vibmod = g_snd_param_byte;
						
						break;
						
					case KSD_CH3_VIBINTERVAL:

						//ru[ggωw
						
						//VIR}hl
						g_snd_param_byte = (*g_ch3_ptr);
						g_ch3_ptr++;
						
						//ێlɍXV
						g_ch3_vibint = g_snd_param_byte;
						
						break;
						
					case KSD_CH3_VIBSTEP:

						//ru[gglw
						
						//VSR}hl
						g_snd_param_byte = (*g_ch3_ptr);
						g_ch3_ptr++;
						
						//ێlɍXV
						g_ch3_vibstep = g_snd_param_byte;
						
						break;
						
					case KSD_ENV_ON:

						//Gx[vL
						g_ch3_env = 1;
						
						break;
						
					case KSD_ENV_OFF:

						//Gx[v
						g_ch3_env = 0;
						
						break;
						
					case KSD_VIB_ON:

						//ru[gL
						g_ch3_vibcnt = 1;
						
						break;
						
					case KSD_VIB_OFF:

						//ru[g
						g_ch3_vibcnt = 0;
						
						break;
						
					case KSD_CH3_REST:

						//CH3̋xw
						
						//擾
						g_snd_param_byte = (*g_ch3_ptr);
						g_ch3_ptr++;
						
						//ĐJE^ێlɔf
						g_ch3_cnt = g_snd_param_byte;
						
						//ʌNA
						g_ch3_decay_step = 0;
						g_ch3_decay_acc  = 0;
						
						//{[ێlZbg
						g_ch3_vol    = 0;
						g_ch3_ctrl1 &= ~0x0F;
						g_ch3_ctrl1 |= g_ch3_vol;
						
						//WX^ɐݒ
						PULSE2CTR1 = g_ch3_ctrl1;
						
						break;
						
					case KSD_LOOP:

						//ItZbg擾čĐf[^|C^߂
						
						g_snd_param_word  = (*g_ch3_ptr) << 8;
						g_ch3_ptr++;
						g_snd_param_word |= (*g_ch3_ptr);
						g_ch3_ptr++;
						
						g_ch3_ptr -= g_snd_param_word;
						
						break;
						
					case KSD_END:

						//Đ~
						g_ch3_ptr = NULL;
						g_ch3_cnt = 0;
						goto ch3exit;
						
						break;
						
					default:
					
						//mȂR}hI
						ksd_init();
						goto ch3exit;
						
						break;
				}
			}
			else
			{
				//ĐJEg
				g_ch3_cnt--;
				
				//
				if(g_ch3_env)	//Gx[vLɑ
				{
					//̃t[ł̉ʌZ
					g_ch3_decay_acc += g_ch3_decay_step;
					g_snd_param_byte = (g_ch3_decay_acc >> 8);
					
					//ʂ̌
					if(g_ch3_vol > 0)
					{
						if(g_ch3_vol < g_snd_param_byte)
						{
							//ɂ
							g_ch3_vol = 0;
							g_ch3_ctrl1 &= ~0x0F;
							
							//WX^ɐݒ
							PULSE2CTR1 = g_ch3_ctrl1;
						}
						else if(g_snd_param_byte > 0)
						{
							//ێlɔf
							g_ch3_vol -= g_snd_param_byte;
							g_ch3_ctrl1 &= ~0x0F;
							g_ch3_ctrl1 |= g_ch3_vol;
							
							//WX^ɐݒ
							PULSE2CTR1 = g_ch3_ctrl1;
							
							//~ϒlXV
							g_ch3_decay_acc &= 0x00FF;
						}
					}
				}
				
				//ru[g
				if(g_ch3_vibcnt > 0)
				{
					if((g_ch3_cnt % g_ch3_vibmod) == 0)
					{
						if(g_ch3_cnt <= g_ch3_vibstart)
						{
							//ru[ĝ߂̎gύX
							
							//ZlƂĂ܂AgƂ납
							//n߂̂ňZɂĂ܂
							g_ch3_freq1 -= g_ch3_vibadd;
							
							PULSE2FREQ1 = g_ch3_freq1;
						
							//ru[g̎gωؑ
							if(g_ch3_vibcnt == g_ch3_vibint)
							{
								g_ch3_vibadd = 0xFF - g_ch3_vibadd + 1;		//](2̕␔\)
								g_ch3_vibcnt  = 1;		//0ɂƃru[gOFFɂȂ̂1ɂ܂
							}
							else
							{	g_ch3_vibcnt++;	}
						}
					}
				}
				break;
			}
		}
ch3exit:;
	}
	
	//======================================================
	// ch4 mCY
	//======================================================
	if(g_ch4_ptr != (unsigned char*)NULL)
	{
		while(1)
		{
			if(g_ch4_cnt == 0)
			{
				//ĐJEg0ɂȂ
				//̃R}hǂ
				g_snd_cmd = (*g_ch4_ptr);
				g_ch4_ptr++;
				
				switch(g_snd_cmd)
				{
					case KSD_CH4_TONE1:

						//CH4F1ɐ؂ւ
						
						//^Cv0:32kbit[hɐݒ
						g_ch4_rnd &= ~0x80;
						//g_ch4_rnd |= (0<<7);	//0Ȃ̂Őݒsv
						
						NOISERND  = g_ch4_rnd;
						
						break;
						
					case KSD_CH4_TONE2:

						//CH4F2ɐ؂ւ
						
						//^Cv1:93bit[hɐݒ
						g_ch4_rnd &= ~0x80;
						g_ch4_rnd |= 0x80;		//0x80 = (1<<7);
						
						NOISERND  = g_ch4_rnd;
						
						break;
						
					case KSD_CH4_FREQ:

						//CH4̎gw
						
						//gl擾
						g_snd_param_byte = (*g_ch4_ptr);
						g_ch4_ptr++;
						
						//ێlɔf
						g_ch4_rnd &= ~0x0F;
						g_ch4_rnd |= (g_snd_param_byte & 0x0F);
						
						//WX^ɐݒ
						NOISERND = g_ch4_rnd;
						
						//{[ێlZbg
						g_ch4_vol   = g_ch4_volset;
						g_ch4_ctrl &= ~0x0F;
						g_ch4_ctrl |= g_ch4_vol;
						
						//WX^ɐݒ
						NOISECTRL = g_ch4_ctrl;
						
						break;
						
					case KSD_CH4_CNT:

						//CH4̍ĐJE^w
						
						//ĐJE^l擾
						g_snd_param_byte = (*g_ch4_ptr);
						g_ch4_ptr++;
						
						//1t[Ƃ̉ʌŒ菬ŌvZ
						if(g_ch4_env)
						{
							g_snd_param_word  = ((unsigned short)g_ch4_vol << 8);	//vol
							g_snd_param_word2 = g_snd_param_byte;					//len
							if(g_ch4_decayQ > 1)
							{	g_snd_param_word2 -= (g_snd_param_byte / g_ch4_decayQ);	}
							g_ch4_decay_step = (g_snd_param_word+(g_snd_param_word2>>1)) / g_snd_param_word2;	//ľܓ
							g_ch4_decay_acc  = 0;
						}
						
						//ێlɍXV
						g_ch4_cnt = g_snd_param_byte;
						
						break;
						
					case KSD_CH4_VOL:

						//CH4̃{[lݒ
						
						//{[l擾
						g_ch4_volset = (*g_ch4_ptr) & 0x0F;
						g_ch4_ptr++;
						
						break;
						
					case KSD_CH4_DECAYQ:

						//Gx[v^C~Ow
						
						//QR}hl
						g_snd_param_byte = (*g_ch4_ptr);
						g_ch4_ptr++;
						
						//ێlɍXV
						g_ch4_decayQ = g_snd_param_byte;
						
						break;
						
					case KSD_ENV_ON:

						//Gx[vL
						g_ch4_env = 1;
						
						break;
						
					case KSD_ENV_OFF:

						//Gx[v
						g_ch4_env = 0;
						
						break;
						
					case KSD_CH4_REST:

						//CH4̋xw
						
						g_snd_param_byte = (*g_ch4_ptr);
						g_ch4_ptr++;
						
						//ĐJE^ێlɔf
						g_ch4_cnt = g_snd_param_byte;
						
						//ʌNA
						g_ch4_decay_step = 0;
						g_ch4_decay_acc  = 0;
												
						//{[ێlZbg
						g_ch4_vol   = 0;
						g_ch4_ctrl &= ~0x0F;
						g_ch4_ctrl |= g_ch4_vol;
						
						//WX^ɐݒ
						NOISECTRL = g_ch4_ctrl;
						
						break;
						
					case KSD_LOOP:

						//ItZbg擾čĐf[^|C^߂
						
						g_snd_param_word  = (*g_ch4_ptr) << 8;
						g_ch4_ptr++;
						g_snd_param_word |= (*g_ch4_ptr);
						g_ch4_ptr++;
						
						g_ch4_ptr -= g_snd_param_word;
						
						break;
						
					case KSD_END:

						//Đ~
						g_ch4_ptr = NULL;
						g_ch4_cnt = 0;
						goto ch4exit;
						
						break;

					default:

						//mȂR}hI
						ksd_init();
						goto ch4exit;
						
						break;
				}
			}
			else
			{
				//ĐJEg
				g_ch4_cnt--;
				
				//
				if(g_ch4_env)	//Gx[vLɑ
				{
					//̃t[ł̉ʌZ
					g_ch4_decay_acc += g_ch4_decay_step;
					g_snd_param_byte = (g_ch4_decay_acc >> 8);
					
					//ʂ̌
					if(g_ch4_vol > 0)
					{
						if(g_ch4_vol < g_snd_param_byte)
						{
							//ɂ
							g_ch4_vol = 0;
							g_ch4_ctrl &= ~0x0F;
							
							//WX^ɐݒ
							NOISECTRL = g_ch4_ctrl;
						}
						else if(g_snd_param_byte > 0)
						{
							//ێlɔf
							g_ch4_vol -= g_snd_param_byte;
							g_ch4_ctrl &= ~0x0F;
							g_ch4_ctrl |= g_ch4_vol;
							
							//WX^ɐݒ
							NOISECTRL = g_ch4_ctrl;
							
							//~ϒlXV
							g_ch4_decay_acc &= 0x00FF;
						}
					}
				}
				break;
			}
		}
ch4exit:;
	}

}
//---------------------------------------------------------------------------

