//
// ksd.h
// KAKAO SOFT Sound Driver
//
// Copyright (c) 2021 ڂ(@voich2014 in Twitter)
//
// Released under the MIT license.
// see https://opensource.org/licenses/MIT
// Where a citation is listed, please also check the license of the citing source.
//

//---------------------------------------------------------------------------
// 萔E}N` 
//---------------------------------------------------------------------------
#ifndef NULL
#define NULL           ((void*)0)		//NULL|C^
#endif //NULL

//TEhhCoR}h
#define KSD_END				(0x00)			//Đ~                       (0 param)
#define KSD_CH1_TONE1		(0x10)			//CH1(`g1)F1ɐ؂ւ        (0 param)
#define KSD_CH1_TONE2		(0x11)			//CH1(`g1)F2ɐ؂ւ        (0 param)
#define KSD_CH1_TONE3		(0x12)			//CH1(`g1)F3ɐ؂ւ        (0 param)
#define KSD_CH2_TONE1		(0x13)			//CH2(Opg)F1ɐ؂ւ         (0 param)
#define KSD_CH2_TONE2		(0x14)			//CH2(Opg)F2ɐ؂ւ         (0 param)
#define KSD_CH3_TONE1		(0x15)			//CH3(`g2)F1ɐ؂ւ        (0 param)
#define KSD_CH3_TONE2		(0x16)			//CH3(`g2)F2ɐ؂ւ        (0 param)
#define KSD_CH3_TONE3		(0x17)			//CH3(`g2)F3ɐ؂ւ        (0 param)
#define KSD_CH4_TONE1		(0x18)			//CH4(mCY)F1ɐ؂ւ         (0 param)
#define KSD_CH4_TONE2		(0x19)			//CH4(mCY)F2ɐ؂ւ         (0 param)
#define KSD_CH1_NOTE		(0x20)			//CH1(`g1)̃m[gԍw         (1 param)
#define KSD_CH2_NOTE		(0x21)			//CH2(Opg)̃m[gԍw          (1 param)
#define KSD_CH3_NOTE		(0x22)			//CH3(`g2)̃m[gԍw         (1 param)
#define KSD_CH4_FREQ		(0x23)			//CH4(mCY)̎gw              (1 param)
#define KSD_CH1_CNT			(0x30)			//CH1(`g1)̍ĐJE^w       (1 param)
#define KSD_CH2_CNT			(0x31)			//CH2(Opg)̍ĐJE^w        (1 param)
#define KSD_CH3_CNT			(0x32)			//CH3(`g2)̍ĐJE^w       (1 param)
#define KSD_CH4_CNT			(0x33)			//CH4(mCY)̍ĐJE^w        (1 param)
#define KSD_CH1_VOL			(0x40)			//CH1(`g1)̃{[lݒ       (1 param)
#define KSD_CH3_VOL			(0x43)			//CH3(`g2)̃{[lݒ       (1 param)
#define KSD_CH4_VOL			(0x44)			//CH4(mCY)̃{[lݒ        (1 param)
#define KSD_ENV_ON			(0x50)			//Gx[vL                   (0 param)
#define KSD_ENV_OFF			(0x51)			//Gx[v                   (0 param)
#define KSD_CH1_DECAYQ		(0x52)			//CH1(`g1)̌^C~Ow     (1 param)
#define KSD_CH3_DECAYQ		(0x53)			//CH3(`g2)̌^C~Ow     (1 param)
#define KSD_CH4_DECAYQ		(0x54)			//CH4(mCY)̌^C~Ow      (1 param)
#define KSD_VIB_ON			(0x60)			//ru[gL                     (0 param)
#define KSD_VIB_OFF			(0x61)			//ru[g                     (0 param)
#define KSD_CH1_VIBDELAY	(0x62)			//CH1(`g1)̃ru[gfBCw (1 param)
#define KSD_CH2_VIBDELAY	(0x63)			//CH2(Opg)̃ru[gfBCw  (1 param)
#define KSD_CH3_VIBDELAY	(0x64)			//CH3(`g2)̃ru[gfBCw (1 param)
#define KSD_CH1_VIBMOD		(0x65)			//CH1(`g1)̃ru[gw   (1 param)
#define KSD_CH2_VIBMOD		(0x66)			//CH2(Opg)̃ru[gw    (1 param)
#define KSD_CH3_VIBMOD		(0x67)			//CH3(`g2)̃ru[gw   (1 param)
#define KSD_CH1_VIBINTERVAL	(0x68)			//CH1(`g1)̃ru[gωw (1 param)
#define KSD_CH2_VIBINTERVAL	(0x69)			//CH2(Opg)̃ru[gωw  (1 param)
#define KSD_CH3_VIBINTERVAL	(0x6A)			//CH3(`g2)̃ru[gωw (1 param)
#define KSD_CH1_VIBSTEP		(0x6B)			//CH1(`g1)̃ru[gωw   (1 param)
#define KSD_CH2_VIBSTEP		(0x6C)			//CH2(Opg)̃ru[gωw    (1 param)
#define KSD_CH3_VIBSTEP		(0x6D)			//CH3(`g2)̃ru[gωw   (1 param)
#define KSD_CH1_REST		(0x70)			//CH1(`g1)̋xw               (1 param)
#define KSD_CH2_REST		(0x71)			//CH2(Opg)̋xw                (1 param)
#define KSD_CH3_REST		(0x72)			//CH3(`g2)̋xw               (1 param)
#define KSD_CH4_REST		(0x73)			//CH4(mCY)̋xw                (1 param)
#define KSD_LOOP			(0x80)			//[vItZbg                     (2 param)


//---------------------------------------------------------------------------
// TEhhCõO[oϐOQ 
//---------------------------------------------------------------------------
extern unsigned char  g_ch1_note;			//CH1(`g1)m[gԍێl
extern unsigned char  g_ch2_note;			//CH2(Opg)m[gԍێl
extern unsigned char  g_ch3_note;			//CH3(`g2)m[gԍێl
extern unsigned char  g_ch4_rnd;			//CH4(mCY)WX^lێl(4bitgl)
extern unsigned char  g_ch1_vol;			//CH1(`g1){[ێl
extern unsigned char  g_ch2_vol;			//CH2(Opg){[ێl
extern unsigned char  g_ch3_vol;			//CH3(`g2){[ێl
extern unsigned char  g_ch4_vol;			//CH4(mCY){[ێl

#pragma zpsym ("g_ch1_note");
#pragma zpsym ("g_ch2_note");
#pragma zpsym ("g_ch3_note");
#pragma zpsym ("g_ch4_rnd");
#pragma zpsym ("g_ch1_vol");
#pragma zpsym ("g_ch2_vol");
#pragma zpsym ("g_ch3_vol");
#pragma zpsym ("g_ch4_vol");

//---------------------------------------------------------------------------
// TEhhCo֐錾 
//---------------------------------------------------------------------------

//TEhhCo
void ksd_init(void);

//BGMĐo^
void ksd_play_bgm(void* bgm_data);

//BGM~
void ksd_stop_bgm(void);

//SE1(`g)Đo^
void ksd_play_se1(void* se_data);

//SE1(`g)~
void ksd_stop_se1(void);

//SE2(mCY)Đo^
void ksd_play_se2(void* se_data);

//SE2(mCY)~
void ksd_stop_se2(void);

//TEhhCoC
void ksd_mainproc(void);

